小Q想要给他的朋友发送一个神秘字符串,但是他发现字符串的过于长了,于是小Q发明了一种压缩算法对字符串中重复的部分进行了压缩,对于字符串中连续的m个相同字符串S将会压缩为[m|S](m为一个整数且1<=m<=100),例如字符串ABCABCABC将会被压缩为[3|ABC],现在小Q的同学收到了小Q发送过来的字符串,你能帮助他进行解压缩么?
输入描述:
输入第一行包含一个字符串s,代表压缩后的字符串。 S的长度<=1000; S仅包含大写字母、[、]、|; 解压后的字符串长度不超过100000; 压缩递归层数不超过10层;
输出描述:
输出一个字符串,代表解压后的字符串。
输入例子1:
HG[3|B[2|CA]]F
输出例子1:
HGBCACABCACABCACAF
例子说明1:
HG[3|B[2|CA]]F−>HG[3|BCACA]F−>HGBCACABCACABCACAF
题解:leetcode原题(https://leetcode-cn.com/problems/decode-string/)直接用栈解决
#include
using namespace std;
int string_to_int(string s) {
int num = 0;
for (int i = 0; i < (int)s.size(); i++) {
num = num * 10 + (s[i] - '0');
}
return num;
}
int main() {
string ss;
cin >> ss;
stack st;
for (int i = 0; i < (int)ss.size(); i++) {
if (ss[i] != ']') {
st.push(ss[i]);
} else {
string foo = "", bar = "";
while (!st.empty()) {
if (st.top() == '|') {
st.pop();
break;
}
foo += st.top();
st.pop();
}
while (!st.empty()) {
if (st.top() == '[') {
st.pop();
break;
}
bar += st.top();
st.pop();
}
reverse(foo.begin(), foo.end());
reverse(bar.begin(), bar.end());
int tt = string_to_int(bar);
while (tt--) {
for (int j = 0; j < (int)foo.size(); j++) {
st.push(foo[j]);
}
}
}
}
string ret = "";
while (!st.empty()) {
ret += (st.top());
st.pop();
}
reverse(ret.begin(), ret.end());
cout << ret << "\n";
return 0;
}
小Q在周末的时候和他的小伙伴来到大城市逛街,一条步行街上有很多高楼,共有n座高楼排成一行。
小Q从第一栋一直走到了最后一栋,小Q从来都没有见到这么多的楼,所以他想知道他在每栋楼的位置处能看到多少栋楼呢?(当前面的楼的高度大于等于后面的楼时,后面的楼将被挡住)
输入描述:
输入第一行将包含一个数字n,代表楼的栋数,接下来的一行将包含n个数字wi(1<=i<=n),代表每一栋楼的高度。
1<=n<=100000;
1<=wi<=100000;
输出描述:
输出一行,包含空格分割的n个数字vi,分别代表小Q在第i栋楼时能看到的楼的数量。
输入例子1:
6 5 3 8 3 2 5
输出例子1:
3 3 5 4 4 4
例子说明1:
当小Q处于位置3时,他可以向前看到位置2,1处的楼,向后看到位置4,6处的楼,加上第3栋楼,共可看到5栋楼。当小Q处于位置4时,他可以向前看到位置3处的楼,向后看到位置5,6处的楼,加上第4栋楼,共可看到4栋楼。
题解:用单调栈解决
#include
using namespace std;
int main() {
int n;
cin >> n;
vector a(n);
for (int i = 0; i < n; i++) {
scanf("%d", &a[i]);
}
stack st;
vector l(n, 0), r(n, 0); // 分别表示向左和向右能看到多少栋房子
for (int i = 1; i < n; i++) {
if (!st.empty() && a[i - 1] < a[st.top()]) {
st.push(i - 1);
} else {
while (!st.empty() && a[i - 1] >= a[st.top()]) {
st.pop();
}
st.push(i - 1);
}
l[i] = (int)st.size();
}
st = stack();
for (int i = n - 2; i >= 0; i--) {
if (!st.empty() && a[i + 1] < a[st.top()]) {
st.push(i + 1);
} else {
while (!st.empty() && a[i + 1] >= a[st.top()]) {
st.pop();
}
st.push(i + 1);
}
r[i] = (int)st.size();
}
for (int i = 0; i < n; i++) {
cout << l[i] + r[i] + 1 << " ";
}
cout << endl;
return 0;
}
由于业绩优秀,公司给小Q放了 n 天的假,身为工作狂的小Q打算在在假期中工作、锻炼或者休息。他有个奇怪的习惯:不会连续两天工作或锻炼。只有当公司营业时,小Q才能去工作,只有当健身房营业时,小Q才能去健身,小Q一天只能干一件事。给出假期中公司,健身房的营业情况,求小Q最少需要休息几天。
输入描述:
第一行一个整数 转存失败重新上传取消 表示放假天数
第二行 n 个数 每个数为0或1,第 i 个数表示公司在第 i 天是否营业
第三行 n 个数 每个数为0或1,第 i 个数表示健身房在第 i 天是否营业
(1为营业 0为不营业)
输出描述:
一个整数,表示小Q休息的最少天数
输入例子1:
4 1 1 0 0 0 1 1 0
输出例子1:
2
例子说明1:
小Q可以在第一天工作,第二天或第三天健身,小Q最少休息2天
题解:假设dp[i][1]表示第i天工作能够休息的最少天数,dp[i][2]表示第i天健身能够休息的最少天数,dp[i][3]表示第i天休息能够休息的最少天数;
dp[i][1] = min(dp[i - 1][2], dp[i - 1][3])
dp[i][2] = min(dp[i - 1][1], dp[i - 1][3])
dp[i][3] = min(dp[i - 1][1], dp[i - 1][2], dp[i - 1][3])
#include
using namespace std;
int dp[100001][4];
int main() {
int n;
cin >> n;
vector a(n), b(n);
for (int i = 0; i < n; i++) {
scanf("%d", &a[i]);
}
for (int i = 0; i < n; i++) {
scanf("%d", &b[i]);
}
for (int i = 0; i < n; i++) {
for (int j = 1; j <= 2; j++) {
dp[i][j] =100001;
}
}
dp[0][3] = 1;
if (a[0]) dp[0][1] = 0;
if (b[0]) dp[0][2] = 0;
for (int i = 1; i < n; i++) {
if (a[i]) {
dp[i][1] = min(dp[i - 1][2], dp[i - 1][3]);
}
if (b[i]) {
dp[i][2] = min(dp[i - 1][1], dp[i - 1][3]);
}
dp[i][3] = min(dp[i - 1][1], min(dp[i - 1][2], dp[i - 1][3])) + 1;
}
cout << min(dp[n - 1][1], min(dp[n - 1][2], dp[n - 1][3])) << "\n";
return 0;
}
小Q在进行一场竞技游戏,这场游戏的胜负关键就在于能否能争夺一条长度为L的河道,即可以看作是[0,L]的一条数轴。
这款竞技游戏当中有n个可以提供视野的道具−真视守卫,第i个真视守卫能够覆盖区间[xi,yi]。现在小Q想知道至少用几个真视守卫就可以覆盖整段河道。
输入描述:
输入包括n+1行。
第一行包括两个正整数n和L(1<=n<=105,1<=L<=109)
接下来的n行,每行两个正整数xi,yi(0<=xi<=yi<=109),表示第i个真视守卫覆盖的区间。
输出描述:
一个整数,表示最少需要的真视守卫数量, 如果无解, 输出-1。
输入例子1:
4 6 3 6 2 4 0 2 4 7
输出例子1:
3
题解:典型的区间覆盖问题(https://blog.csdn.net/gh6267/article/details/104047551)
#include
using namespace std;
struct Sec{
int l, r;
};
int main() {
int n, L;
cin >> n >> L;
vector vec;
for (int i = 0; i < n; i++) {
Sec s;
scanf("%d %d", &s.l, &s.r);
vec.push_back(s);
}
sort(vec.begin(), vec.end(), [&](Sec x, Sec y){
if (x.l == y.l) {
return x.r > y.r;
}
return x.l < y.l;
});
int R = vec[0].r;
int i = 1;
int tt = 1;
while (R < L && i < n) {
Sec best;
int clen = 0;
for (; i < n; i++) {
if (vec[i].l <= R) {
if (vec[i].r - R >= clen) {
clen = vec[i].r - R;
best = vec[i];
}
} else {
if (clen == 0) {
cout << "-1" << "\n";
return 0;
}
break;
}
}
if (clen != 0) {
R = best.r;
tt++;
}
}
if (R < L) {
cout << "-1" << "\n";
} else {
cout << tt << "\n";
}
return 0;
}